## suitesparse 5.7.1+dfsg

=== CHOLMOD/Makefile ===
#-------------------------------------------------------------------------------
# CHOLMOD Makefile
#-------------------------------------------------------------------------------

SUITESPARSE ?= $(realpath $(CURDIR)/..)
export SUITESPARSE

default: all

include ../SuiteSparse_config/SuiteSparse_config.mk

# Compile the C-callable libraries and the Demo programs.
all:
	( cd Lib ; $(MAKE) --jobs=$(JOBS) )
	( cd Demo ; $(MAKE) )

# Compile the C-callable libraries only.
library:
	( cd Lib ; $(MAKE) --jobs=$(JOBS) )

# compile the static libraries only
static:
	( cd Lib    ; $(MAKE) static --jobs=$(JOBS) )

# Remove all files not in the original distribution
purge:
	( cd Tcov ; $(MAKE) purge )
	( cd Lib ; $(MAKE) purge )
	( cd Valgrind ; $(MAKE) dopurge )
	( cd Demo ; $(MAKE) purge )
	( cd Doc ; $(MAKE) purge )
	( cd MATLAB ; $(RM) $(CLEAN) rename.h *.mex* GKlib_util.c GKlib_graph.c )

# Remove all files not in the original distribution, except keep the 
# compiled libraries.
clean:
	( cd Tcov ; $(MAKE) clean )
	( cd Lib ; $(MAKE) clean )
	( cd Valgrind ; $(MAKE) clean )
	( cd Demo ; $(MAKE) clean )
	( cd MATLAB ; $(RM) $(CLEAN) )

distclean: purge

ccode: all

# Run the test coverage suite.  Takes about 40 minutes on a 3.2GHz Pentium.
# Requires Linux (gcc, gcov).
cov:
	( cd Tcov ; $(MAKE) )

# Run the test coverage suite using Valgrind.  This takes a *** long *** time.
valgrind:
	( cd Valgrind ; $(MAKE) )

# Compile the C-callable libraries and the Demo programs.
demos:
	( cd Demo ; $(MAKE) )

# create PDF documents for the original distribution
docs:
	( cd Doc    ; $(MAKE) )

# install CHOLMOD
install:
	( cd Lib ; $(MAKE) install )

# uninstall CHOLMOD
uninstall:
	( cd Lib ; $(MAKE) uninstall )

=== GraphBLAS/Makefile ===
#-------------------------------------------------------------------------------
# GraphBLAS/Makefile
#-------------------------------------------------------------------------------

# SuiteSparse:GraphBLAS, Timothy A. Davis, (c) 2017-2020, All Rights Reserved.
# http://suitesparse.com   See GraphBLAS/Doc/License.txt for license.

#-------------------------------------------------------------------------------

# simple Makefile for GraphBLAS, relies on cmake to do the actual build.  Use
# the CMAKE_OPTIONS argument to this Makefile to pass options to cmake.

JOBS ?= 1

default: library

# just build the dynamic library; do not run the demo
library:
	( cd build ; cmake $(CMAKE_OPTIONS) .. ; $(MAKE) --jobs=$(JOBS) )

# just run the demos: assumes the library is already compiled
run:
	( cd Demo ; ./demo )

# just do 'make' in build; do not rerun the cmake script
remake:
	( cd build ; $(MAKE) --jobs=$(JOBS) )

# just run cmake; do not compile
cmake:
	( cd build ; cmake $(CMAKE_OPTIONS) .. ; )

# build both the static and dynamic libraries do not run the demo
static:
	( cd build ; cmake $(CMAKE_OPTIONS) -DBUILD_GRB_STATIC_LIBRARY=1 .. ; $(MAKE) --jobs=$(JOBS) )

# installs GraphBLAS to the install location defined by cmake, usually
# /usr/local/lib and /usr/local/include
install:
	( cd build ; $(MAKE) install )

# create the Doc/GraphBLAS_UserGuide.pdf
docs:
	( cd Doc ; $(MAKE) )

# remove any installed libraries and #include files
uninstall:
	- xargs rm < build/install_manifest.txt

clean: distclean

purge: distclean

# remove all files not in the distribution
distclean:
	rm -rf build/* Demo/*.out Demo/complex_demo_out.m Tcov/log.txt
	rm -rf Config/*.tmp Source/control.m4
	rm -rf Doc/html/* Doc/*.tmp
	( cd GraphBLAS/test/tcov ; $(MAKE) distclean )
	( cd GraphBLAS/@GrB/private ; $(MAKE) distclean )
	( cd Test ; $(MAKE) distclean )
	( cd Tcov ; $(MAKE) distclean )
	( cd Doc  ; $(MAKE) distclean )
	( cd alternative  ; $(MAKE) distclean )

=== RBio/Makefile ===
#-------------------------------------------------------------------------------
# RBio Makefile
#-------------------------------------------------------------------------------

SUITESPARSE ?= $(realpath $(CURDIR)/..)
export SUITESPARSE

default: all

include ../SuiteSparse_config/SuiteSparse_config.mk

# Compile the C-callable libraries and the Demo programs.
all:
	( cd Lib ; $(MAKE) )
	( cd Demo ; $(MAKE) )

# Compile the C-callable libraries only.
library:
	( cd Lib ; $(MAKE) )

# compile the static libraries only
static:
	( cd Lib    ; $(MAKE) static )

# Remove all files not in the original distribution
purge:
	( cd Tcov ; $(MAKE) purge )
	( cd Lib ; $(MAKE) purge )
	( cd Demo ; $(MAKE) purge )
	( cd RBio ; $(RM) $(CLEAN) private/temp.rb *.mex* )

# Remove all files not in the original distribution, except keep the 
# compiled libraries.
clean:
	( cd Tcov ; $(MAKE) clean )
	( cd Lib ; $(MAKE) clean )
	( cd Demo ; $(MAKE) clean )
	( cd RBio ; $(RM) $(CLEAN) private/temp.rb )

distclean: purge

ccode: all

# Run the test coverage suite.
cov:
	( cd Tcov ; $(MAKE) go )

# Run the test coverage suite using Valgrind.
valgrind:
	( cd Valgrind ; $(MAKE) )

# Compile the C-callable libraries and the Demo programs.
demos:
	( cd Demo ; $(MAKE) )

# install RBio
install:
	( cd Lib ; $(MAKE) install )

# uninstall RBio
uninstall:
	( cd Lib ; $(MAKE) uninstall )

=== CCOLAMD/Lib/Makefile ===
#-------------------------------------------------------------------------------
# CCOLAMD Lib/Makefile
#-------------------------------------------------------------------------------

LIBRARY = libccolamd
VERSION = 2.9.6
SO_VERSION = 2

default: library

include ../../SuiteSparse_config/SuiteSparse_config.mk

# CCOLAMD depends on SuiteSparse_config
LDLIBS += -lsuitesparseconfig

# compile and install in SuiteSparse/lib
library:
	$(MAKE) install INSTALL=$(SUITESPARSE)

I = -I../Include -I../../SuiteSparse_config

INC = ../Include/ccolamd.h ../../SuiteSparse_config/SuiteSparse_config.h

SRC = ../Source/ccolamd.c

OBJ = ccolamd.o ccolamd_l.o

ccolamd.o: $(SRC) $(INC)
	$(CC) $(CF) $(I) -c ../Source/ccolamd.c

ccolamd_l.o: $(SRC) $(INC)
	$(CC) $(CF) $(I) -c ../Source/ccolamd.c -DDLONG -o ccolamd_l.o

# creates libccolamd.a, a C-callable CCOLAMD library
static: $(AR_TARGET)

$(AR_TARGET):  $(OBJ)
	$(ARCHIVE)  $@ $^
	- $(RANLIB) $@ 

ccode: library

clean:
	- $(RM) -r $(CLEAN)

purge: distclean

distclean: clean
	- $(RM) -r $(PURGE)

# install CCOLAMD
install: $(AR_TARGET) $(INSTALL_LIB)/$(SO_TARGET)

$(INSTALL_LIB)/$(SO_TARGET): $(OBJ)
	@mkdir -p $(INSTALL_LIB)
	@mkdir -p $(INSTALL_INCLUDE)
	@mkdir -p $(INSTALL_DOC)
	$(CC) $(SO_OPTS) $^ -o $@ $(LDLIBS)
	( cd $(INSTALL_LIB) ; ln -sf $(SO_TARGET) $(SO_PLAIN) )
	( cd $(INSTALL_LIB) ; ln -sf $(SO_TARGET) $(SO_MAIN) )
	$(CP) ../Include/ccolamd.h $(INSTALL_INCLUDE)
	$(CP) ../README.txt $(INSTALL_DOC)/CCOLAMD_README.txt
	chmod 755 $(INSTALL_LIB)/$(SO_TARGET)
	chmod 644 $(INSTALL_INCLUDE)/ccolamd.h
	chmod 644 $(INSTALL_DOC)/CCOLAMD_README.txt

uninstall:
	$(RM) $(INSTALL_LIB)/$(SO_TARGET)
	$(RM) $(INSTALL_LIB)/$(SO_PLAIN)
	$(RM) $(INSTALL_LIB)/$(SO_MAIN)
	$(RM) $(INSTALL_INCLUDE)/ccolamd.h
	$(RM) $(INSTALL_DOC)/CCOLAMD_README.txt

=== CXSparse/Tcov/Makefile ===

# To run with valgrind:
V =
# V = valgrind -q

# Linux test coverage
CC = gcc
CFLAGS = -O -g -fprofile-arcs -ftest-coverage \
    	-Wall -W -Wshadow -Wmissing-prototypes -Wstrict-prototypes \
    	-Wredundant-decls -Wnested-externs -Wdisabled-optimization -ansi \
	-Wno-unused-parameter -I../Include \
        -I../Demo -I../../SuiteSparse_config

C = $(CC) $(CFLAGS)

run: all run_convert run_di run_dl run_ci run_cl
	./covall

all:	cs_demo1_di cs_demo2_di cs_demo3_di cstcov_test_di \
	cs_demo1_dl cs_demo2_dl cs_demo3_dl cstcov_test_dl \
	cs_demo1_ci cs_demo2_ci cs_demo3_ci cstcov_test_ci \
	cs_demo1_cl cs_demo2_cl cs_demo3_cl cstcov_test_cl \
	cs_idemo cs_ldemo

CS_DI = cs_add_di.o cs_amd_di.o cs_chol_di.o cs_cholsol_di.o cs_counts_di.o \
	cs_cumsum_di.o cs_droptol_di.o cs_dropzeros_di.o cs_dupl_di.o \
	cs_entry_di.o cs_etree_di.o cs_fkeep_di.o cs_gaxpy_di.o cs_happly_di.o \
	cs_house_di.o cs_ipvec_di.o cs_lsolve_di.o cs_ltsolve_di.o cs_lu_di.o \
	cs_lusol_di.o cs_util_di.o cs_multiply_di.o cs_permute_di.o \
	cs_pinv_di.o cs_post_di.o cs_pvec_di.o cs_qr_di.o cs_qrsol_di.o \
	cs_scatter_di.o cs_schol_di.o cs_sqr_di.o cs_symperm_di.o cs_tdfs_di.o \
	cs_transpose_di.o cs_compress_di.o cs_usolve_di.o cs_scc_di.o \
	cs_maxtrans_di.o cs_dmperm_di.o cs_updown_di.o cs_print_di.o \
	cs_norm_di.o cs_load_di.o cs_dfs_di.o cstcov_malloc_test_di.o \
	cs_utsolve_di.o cs_reach_di.o cs_spsolve_di.o \
	cs_leaf_di.o cs_ereach_di.o cs_randperm_di.o

CS_DL = cs_add_dl.o cs_amd_dl.o cs_chol_dl.o cs_cholsol_dl.o cs_counts_dl.o \
	cs_cumsum_dl.o cs_droptol_dl.o cs_dropzeros_dl.o cs_dupl_dl.o \
	cs_entry_dl.o cs_etree_dl.o cs_fkeep_dl.o cs_gaxpy_dl.o cs_happly_dl.o \
	cs_house_dl.o cs_ipvec_dl.o cs_lsolve_dl.o cs_ltsolve_dl.o cs_lu_dl.o \
	cs_lusol_dl.o cs_util_dl.o cs_multiply_dl.o cs_permute_dl.o \
	cs_pinv_dl.o cs_post_dl.o cs_pvec_dl.o cs_qr_dl.o cs_qrsol_dl.o \
	cs_scatter_dl.o cs_schol_dl.o cs_sqr_dl.o cs_symperm_dl.o cs_tdfs_dl.o \
	cs_transpose_dl.o cs_compress_dl.o cs_usolve_dl.o cs_scc_dl.o \
	cs_maxtrans_dl.o cs_dmperm_dl.o cs_updown_dl.o cs_print_dl.o \
	cs_norm_dl.o cs_load_dl.o cs_dfs_dl.o cstcov_malloc_test_dl.o \
	cs_utsolve_dl.o cs_reach_dl.o cs_spsolve_dl.o \
	cs_leaf_dl.o cs_ereach_dl.o cs_randperm_dl.o

CS_CI = cs_add_ci.o cs_amd_ci.o cs_chol_ci.o cs_cholsol_ci.o cs_counts_ci.o \
	cs_cumsum_ci.o cs_droptol_ci.o cs_dropzeros_ci.o cs_dupl_ci.o \
	cs_entry_ci.o cs_etree_ci.o cs_fkeep_ci.o cs_gaxpy_ci.o cs_happly_ci.o \
	cs_house_ci.o cs_ipvec_ci.o cs_lsolve_ci.o cs_ltsolve_ci.o cs_lu_ci.o \
	cs_lusol_ci.o cs_util_ci.o cs_multiply_ci.o cs_permute_ci.o \
	cs_pinv_ci.o cs_post_ci.o cs_pvec_ci.o cs_qr_ci.o cs_qrsol_ci.o \
	cs_scatter_ci.o cs_schol_ci.o cs_sqr_ci.o cs_symperm_ci.o cs_tdfs_ci.o \
	cs_transpose_ci.o cs_compress_ci.o cs_usolve_ci.o cs_scc_ci.o \
	cs_maxtrans_ci.o cs_dmperm_ci.o cs_updown_ci.o cs_print_ci.o \
	cs_norm_ci.o cs_load_ci.o cs_dfs_ci.o cstcov_malloc_test_ci.o \
	cs_utsolve_ci.o cs_reach_ci.o cs_spsolve_ci.o \
	cs_leaf_ci.o cs_ereach_ci.o cs_randperm_ci.o

CS_CL = cs_add_cl.o cs_amd_cl.o cs_chol_cl.o cs_cholsol_cl.o cs_counts_cl.o \
	cs_cumsum_cl.o cs_droptol_cl.o cs_dropzeros_cl.o cs_dupl_cl.o \
	cs_entry_cl.o cs_etree_cl.o cs_fkeep_cl.o cs_gaxpy_cl.o cs_happly_cl.o \
	cs_house_cl.o cs_ipvec_cl.o cs_lsolve_cl.o cs_ltsolve_cl.o cs_lu_cl.o \
	cs_lusol_cl.o cs_util_cl.o cs_multiply_cl.o cs_permute_cl.o \
	cs_pinv_cl.o cs_post_cl.o cs_pvec_cl.o cs_qr_cl.o cs_qrsol_cl.o \
	cs_scatter_cl.o cs_schol_cl.o cs_sqr_cl.o cs_symperm_cl.o cs_tdfs_cl.o \
	cs_transpose_cl.o cs_compress_cl.o cs_usolve_cl.o cs_scc_cl.o \
	cs_maxtrans_cl.o cs_dmperm_cl.o cs_updown_cl.o cs_print_cl.o \
	cs_norm_cl.o cs_load_cl.o cs_dfs_cl.o cstcov_malloc_test_cl.o \
	cs_utsolve_cl.o cs_reach_cl.o cs_spsolve_cl.o \
	cs_leaf_cl.o cs_ereach_cl.o cs_randperm_cl.o

OBJ = $(CS_DI) $(CS_DL) $(CS_CI) $(CS_CL) cs_convert.o

$(OBJ): ../Include/cs.h cstcov_malloc_test.h Makefile


.PRECIOUS: %demo.c %demo1.c %demo2.c %demo3.c cs_%.c cs_%_ci.c cs_%_cl.c cs_%_di.c cs_%_dl.c cstcov_%.c


%demo.c:
	- ln -s ../Demo/$*demo.c

%demo1.c:
	- ln -s ../Demo/$*demo1.c

%demo2.c:
	- ln -s ../Demo/$*demo2.c

%demo3.c:
	- ln -s ../Demo/$*demo3.c


cstcov_%.c:
	- ln -s cstcov_malloc_test.c cstcov_$*.c

cs_convert.c:
	- ln -s ../Source/cs_convert.c

cs_%_ci.c:
	- ln -s ../Source/cs_$*.c cs_$*_ci.c

cs_%_di.c:
	- ln -s ../Source/cs_$*.c cs_$*_di.c

cs_%_dl.c:
	- ln -s ../Source/cs_$*.c cs_$*_dl.c

cs_%_cl.c:
	- ln -s ../Source/cs_$*.c cs_$*_cl.c


%_di.o: %_di.c
	$(C) -c $<

%_dl.o: %_dl.c
	$(C) -DCS_LONG -c $<

%_ci.o: %_ci.c
	$(C) -DCS_COMPLEX -c $<

%_cl.o: %_cl.c
	$(C) -DCS_LONG -DCS_COMPLEX -c $<


cs_idemo: $(OBJ) cs_idemo.c
	$(C) -o cs_idemo cs_idemo.c $(OBJ) -lm

cs_ldemo: $(OBJ) cs_ldemo.c
	$(C) -o cs_ldemo cs_ldemo.c $(OBJ) -lm


cs_demo1_di: $(CS_DI) cs_di_demo1.c
	$(C) -o cs_demo1_di cs_di_demo1.c $(CS_DI) -lm

cs_demo2_di: $(CS_DI) cs_di_demo2.c cs_di_demo.c
	$(C) -o cs_demo2_di cs_di_demo2.c cs_di_demo.c $(CS_DI) -lm

cs_demo3_di: $(CS_DI) cs_di_demo3.c cs_di_demo.c
	$(C) -o cs_demo3_di cs_di_demo3.c cs_di_demo.c $(CS_DI) -lm

cstcov_test_di: $(CS_DI) cstcov_test.c cs_di_demo.c
	$(C) -o cstcov_test_di cstcov_test.c cs_di_demo.c $(CS_DI) -lm


cs_demo1_dl: $(CS_DL) cs_dl_demo1.c
	$(C) -DCS_LONG -o cs_demo1_dl cs_dl_demo1.c $(CS_DL) -lm

cs_demo2_dl: $(CS_DL) cs_dl_demo2.c cs_dl_demo.c
	$(C) -DCS_LONG -o cs_demo2_dl cs_dl_demo2.c cs_dl_demo.c $(CS_DL) -lm

cs_demo3_dl: $(CS_DL) cs_dl_demo3.c cs_dl_demo.c
	$(C) -DCS_LONG -o cs_demo3_dl cs_dl_demo3.c cs_dl_demo.c $(CS_DL) -lm

cstcov_test_dl: $(CS_DL) cstcov_test.c cs_dl_demo.c
	$(C) -DCS_LONG -o cstcov_test_dl cstcov_test.c cs_dl_demo.c $(CS_DL) -lm


cs_demo1_ci: $(CS_CI) cs_ci_demo1.c
	$(C) -DCS_COMPLEX -o cs_demo1_ci cs_ci_demo1.c $(CS_CI) -lm

cs_demo2_ci: $(CS_CI) cs_ci_demo2.c cs_ci_demo.c
	$(C) -DCS_COMPLEX -o cs_demo2_ci cs_ci_demo2.c cs_ci_demo.c $(CS_CI) -lm

cs_demo3_ci: $(CS_CI) cs_ci_demo3.c cs_ci_demo.c
	$(C) -DCS_COMPLEX -o cs_demo3_ci cs_ci_demo3.c cs_ci_demo.c $(CS_CI) -lm

cstcov_test_ci: $(CS_CI) cstcov_test.c cs_ci_demo.c
	$(C) -DCS_COMPLEX -o cstcov_test_ci cstcov_test.c cs_ci_demo.c $(CS_CI) -lm


cs_demo1_cl: $(CS_CL) cs_cl_demo1.c
	$(C) -DCS_LONG -DCS_COMPLEX -o cs_demo1_cl cs_cl_demo1.c $(CS_CL) -lm

cs_demo2_cl: $(CS_CL) cs_cl_demo2.c cs_cl_demo.c
	$(C) -DCS_LONG -DCS_COMPLEX -o cs_demo2_cl cs_cl_demo2.c cs_cl_demo.c $(CS_CL) -lm

cs_demo3_cl: $(CS_CL) cs_cl_demo3.c cs_cl_demo.c
	$(C) -DCS_LONG -DCS_COMPLEX -o cs_demo3_cl cs_cl_demo3.c cs_cl_demo.c $(CS_CL) -lm

cstcov_test_cl: $(CS_CL) cstcov_test.c cs_cl_demo.c
	$(C) -DCS_LONG -DCS_COMPLEX -o cstcov_test_cl cstcov_test.c cs_cl_demo.c $(CS_CL) -lm


run_convert: cs_idemo cs_ldemo
	- $(V) ./cs_idemo < ../Matrix/t2
	- $(V) ./cs_ldemo < ../Matrix/t2

run_di: cs_demo1_di cs_demo2_di cs_demo3_di cstcov_test_di
	- $(V) ./cs_demo1_di < ../Matrix/t1
	- $(V) ./cs_demo1_di < nil
	- $(V) ./cs_demo1_di < zero
	- $(V) ./cs_demo2_di < nil
	- $(V) ./cs_demo2_di < zero
	- $(V) ./cs_demo2_di < ../Matrix/t1
	- $(V) ./cs_demo2_di < ../Matrix/bcsstk01
	- $(V) ./cs_demo2_di < ../Matrix/fs_183_1
	- $(V) ./cs_demo2_di < ../Matrix/west0067
	- $(V) ./cs_demo2_di < ../Matrix/lp_afiro
	- $(V) ./cs_demo2_di < ../Matrix/ash219
	- $(V) ./cs_demo2_di < ../Matrix/mbeacxc
	- $(V) ./cs_demo2_di < ../Matrix/bcsstk16
	- $(V) ./cs_demo2_di < ../Matrix/ibm32a
	- $(V) ./cs_demo2_di < ../Matrix/ibm32b
	- $(V) ./cs_demo3_di < nil
	- $(V) ./cs_demo3_di < ../Matrix/bcsstk01
	- $(V) ./cs_demo3_di < ../Matrix/bcsstk16
	- $(V) ./cstcov_test_di nil > test_di_nil.out
	- $(V) ./cstcov_test_di zero > test_di_zero.out
	- $(V) ./cstcov_test_di ../Matrix/t1 > test_di_t1.out
	- $(V) ./cstcov_test_di ../Matrix/bcsstk01 > test_di_k1.out
	- $(V) ./cstcov_test_di ../Matrix/fs_183_1 > test_di_fs.out
	- $(V) ./cstcov_test_di ../Matrix/west0067 > test_di_we.out
	- $(V) ./cstcov_test_di ../Matrix/ash219 > test_di_ash.out
	- $(V) ./cstcov_test_di ../Matrix/lp_afiro > test_di_afiro.out

run_dl: cs_demo1_dl cs_demo2_dl cs_demo3_dl cstcov_test_dl
	- $(V) ./cs_demo1_dl < ../Matrix/t1
	- $(V) ./cs_demo1_dl < nil
	- $(V) ./cs_demo1_dl < zero
	- $(V) ./cs_demo2_dl < nil
	- $(V) ./cs_demo2_dl < zero
	- $(V) ./cs_demo2_dl < ../Matrix/t1
	- $(V) ./cs_demo2_dl < ../Matrix/bcsstk01
	- $(V) ./cs_demo2_dl < ../Matrix/fs_183_1
	- $(V) ./cs_demo2_dl < ../Matrix/west0067
	- $(V) ./cs_demo2_dl < ../Matrix/lp_afiro
	- $(V) ./cs_demo2_dl < ../Matrix/ash219
	- $(V) ./cs_demo2_dl < ../Matrix/mbeacxc
	- $(V) ./cs_demo2_dl < ../Matrix/bcsstk16
	- $(V) ./cs_demo2_dl < ../Matrix/ibm32a
	- $(V) ./cs_demo2_dl < ../Matrix/ibm32b
	- $(V) ./cs_demo3_dl < nil
	- $(V) ./cs_demo3_dl < ../Matrix/bcsstk01
	- $(V) ./cs_demo3_dl < ../Matrix/bcsstk16
	- $(V) ./cstcov_test_dl nil > test_dl_nil.out
	- $(V) ./cstcov_test_dl zero > test_dl_zero.out
	- $(V) ./cstcov_test_dl ../Matrix/t1 > test_dl_t1.out
	- $(V) ./cstcov_test_dl ../Matrix/bcsstk01 > test_dl_k1.out
	- $(V) ./cstcov_test_dl ../Matrix/fs_183_1 > test_dl_fs.out
	- $(V) ./cstcov_test_dl ../Matrix/west0067 > test_dl_we.out
	- $(V) ./cstcov_test_dl ../Matrix/ash219 > test_dl_ash.out
	- $(V) ./cstcov_test_dl ../Matrix/lp_afiro > test_dl_afiro.out

run_ci: cs_demo1_ci cs_demo2_ci cs_demo3_ci cstcov_test_ci
	- $(V) ./cs_demo1_ci < ../Matrix/t2
	- $(V) ./cs_demo2_ci < ../Matrix/t2
	- $(V) ./cs_demo1_ci < czero
	- $(V) ./cs_demo2_ci < czero
	- $(V) ./cs_demo1_ci < ../Matrix/t3
	- $(V) ./cs_demo2_ci < ../Matrix/t3
	- $(V) ./cs_demo1_ci < ../Matrix/t4
	- $(V) ./cs_demo2_ci < ../Matrix/t4
	- $(V) ./cs_demo2_ci < ../Matrix/c_west0067
	- $(V) ./cs_demo2_ci < ../Matrix/c_mbeacxc
	- $(V) ./cs_demo2_ci < ../Matrix/c_ibm32a
	- $(V) ./cs_demo2_ci < ../Matrix/c_ibm32b
	- $(V) ./cs_demo2_ci < ../Matrix/young1c
	- $(V) ./cs_demo2_ci < ../Matrix/qc324
	- $(V) ./cs_demo2_ci < ../Matrix/neumann
	- $(V) ./cs_demo2_ci < ../Matrix/c4
	- $(V) ./cs_demo3_ci < ../Matrix/c4
	- $(V) ./cs_demo2_ci < ../Matrix/mhd1280b
	- $(V) ./cs_demo3_ci < ../Matrix/mhd1280b
	- $(V) ./cstcov_test_ci ../Matrix/t2 > test_ci_t2.out
	- $(V) ./cstcov_test_ci ../Matrix/young1c > test_ci_young1c.out
	- $(V) ./cstcov_test_ci ../Matrix/qc324 > test_ci_qc324.out
	- $(V) ./cstcov_test_ci ../Matrix/neumann > test_ci_neumann.out
	- $(V) ./cstcov_test_ci ../Matrix/mhd1280b > test_ci_mhd1280b.out

run_cl: cs_demo1_cl cs_demo2_cl cs_demo3_cl cstcov_test_cl
	- $(V) ./cs_demo1_cl < ../Matrix/t2
	- $(V) ./cs_demo2_cl < ../Matrix/t2
	- $(V) ./cs_demo1_cl < czero
	- $(V) ./cs_demo2_cl < czero
	- $(V) ./cs_demo1_cl < ../Matrix/t3
	- $(V) ./cs_demo2_cl < ../Matrix/t3
	- $(V) ./cs_demo1_cl < ../Matrix/t4
	- $(V) ./cs_demo2_cl < ../Matrix/t4
	- $(V) ./cs_demo2_cl < ../Matrix/c_west0067
	- $(V) ./cs_demo2_cl < ../Matrix/c_mbeacxc
	- $(V) ./cs_demo2_cl < ../Matrix/c_ibm32a
	- $(V) ./cs_demo2_cl < ../Matrix/c_ibm32b
	- $(V) ./cs_demo2_cl < ../Matrix/young1c
	- $(V) ./cs_demo2_cl < ../Matrix/qc324
	- $(V) ./cs_demo2_cl < ../Matrix/neumann
	- $(V) ./cs_demo2_cl < ../Matrix/c4
	- $(V) ./cs_demo3_cl < ../Matrix/c4
	- $(V) ./cs_demo2_cl < ../Matrix/mhd1280b
	- $(V) ./cs_demo3_cl < ../Matrix/mhd1280b
	- $(V) ./cstcov_test_cl ../Matrix/t2 > test_cl_t2.out
	- $(V) ./cstcov_test_cl ../Matrix/young1c > test_cl_young1c.out
	- $(V) ./cstcov_test_cl ../Matrix/qc324 > test_cl_qc324.out
	- $(V) ./cstcov_test_cl ../Matrix/neumann > test_cl_neumann.out
	- $(V) ./cstcov_test_cl ../Matrix/mhd1280b > test_cl_mhd1280b.out


readhb: readhb.f
	f77 -o readhb readhb.f

readhb.f:
	- ln -s ../Demo/readhb.f

clean:
	- $(RM) *.o *.bbg *.da *.gcov *.gcda *.gcno

purge: distclean

distclean: clean
	- $(RM) readhb *.out *.a cov.sort
	- $(RM) cs_demo1_di cs_demo2_di cs_demo3_di cstcov_test_di
	- $(RM) cs_demo1_dl cs_demo2_dl cs_demo3_dl cstcov_test_dl
	- $(RM) cs_demo1_ci cs_demo2_ci cs_demo3_ci cstcov_test_ci
	- $(RM) cs_demo1_cl cs_demo2_cl cs_demo3_cl cstcov_test_cl
	- $(RM) cs_idemo cs_ldemo
	- $(RM) cs_*.c
	- $(RM) cs*_di.c cs*_dl.c cs*_ci.c cs*_cl.c
	- $(RM) -r *.dSYM

=== GraphBLAS/Tcov/Makefile ===
#-------------------------------------------------------------------------------
# GraphBLAS/Tcov/Makefile
#-------------------------------------------------------------------------------

# SuiteSparse:GraphBLAS, Timothy A. Davis, (c) 2017-2020, All Rights Reserved.
# http://suitesparse.com   See GraphBLAS/Doc/License.txt for license.

#-------------------------------------------------------------------------------

UNAME := $(shell uname)

# pick your compiler:
# CC = gcc
# CC = cc
# CC = clang
# CC = xlc
# CC = gcc-8
# CC = icc
ifeq ($(UNAME),Darwin)
    CC = gcc-8
else
    CC = gcc
endif

SRC = tmp_source/*
INC = tmp_include/*
SRC2 = $(notdir $(wildcard $(SRC)))
OBJ = $(SRC2:.c=.o)
LDFLAGS = -fopenmp
CFLAGS = -g -std=c11 -fopenmp -fexceptions -fPIC -Wno-pragmas -DGBTESTCOV
CPPFLAGS = -Itmp_include -DGBCOVER
SO_OPTS = $(LDFLAGS)

ifeq ($(UNAME),Darwin)
    # Mac
    CFLAGS += -fno-common
    SO_NAME = libgraphblas_tcov.dylib
    SO_OPTS += -dynamiclib -shared -undefined dynamic_lookup
else
    # Linux
    SO_NAME = libgraphblas_tcov.so
    SO_OPTS += -shared -Wl,-soname -Wl,$(SO_NAME) -Wl,--no-undefined
endif

default: $(SO_NAME)

%.o: tmp_source/%.c $(INC)
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $< -o $(notdir $@)

$(SO_NAME): $(OBJ)
	$(CC) $(SO_OPTS) $^ -o $@ -lm

.KEEP: $(OBJ)

clean:
	$(RM) *.o

distclean: clean
	$(RM) *.mex* tmp*/* errlog*.txt grbstat.mat fprint.txt
	$(RM) libgraphblas_tcov.*

purge: distclean
	$(RM) log.txt

=== GraphBLAS/alternative/Makefile ===
#-------------------------------------------------------------------------------
# GraphBLAS/alternative/Makefile
#-------------------------------------------------------------------------------

#  SuiteSparse:GraphBLAS, Timothy A. Davis, (c) 2017-2020, All Rights Reserved.
#  http://suitesparse.com   See GraphBLAS/Doc/License.txt for license.

#-------------------------------------------------------------------------------

VER1 = 3
VER2 = 2
VER3 = 0

# pick your compiler:
  CC = gcc
# CC = cc
# CC = clang
# CC = xlc
# CC = gcc-8
# CC = icc -mp1

# note that -mp1 is essential for icc, for proper Inf and NaN behavior.

SRC = ../Source/*.c ../Source/Generated/*.c
INC = ../Include/*.h ../Source/*.h ../Source/Template/* ../Source/Generated/*.h ../Source/Generator/*.h 
SRC2 = $(notdir $(wildcard $(SRC)))
OBJ = $(SRC2:.c=.o)
LDFLAGS = -fopenmp -lm
CFLAGS = -O3 -std=c11 -fopenmp -fexceptions -fPIC -DUSER_OPENMP_THREADS
CPPFLAGS = -I../Include -I../Source -I../Source/Template -I../Source/Generated -I../Source/Generator
SO_OPTS = $(LDFLAGS)

UNAME := $(shell uname)
ifeq ($(UNAME),Darwin)
    # Mac
    CFLAGS += -fno-common
    SO_NAME = libgraphblas.dylib.$(VER1).$(VER2).$(VER3)
    SO_NAME0 = libgraphblas.dylib
    SO_NAME1 = libgraphblas.dylib.$(VER1)
    SO_OPTS += -dynamiclib -shared -undefined dynamic_lookup
else
    # Linux
    SO_NAME = libgraphblas.so.$(VER1).$(VER2).$(VER3)
    SO_NAME0 = libgraphblas.so
    SO_NAME1 = libgraphblas.so.$(VER1)
    SO_OPTS += -shared -Wl,-soname -Wl,$(SO_NAME)
endif

%.o: ../Source/%.c $(INC)
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $< -o $(notdir $@)

%.o: ../Source/Generated/%.c $(INC)
	$(CC) -c $(CFLAGS) $(CPPFLAGS) $< -o $(notdir $@)

default: $(SO_NAME)

$(SO_NAME): $(OBJ)
	$(CC) $(SO_OPTS) $^ -o $@

.KEEP: $(OBJ)

static: libgraphblas.a

libgraphblas.a: $(OBJ)
	ar -rv $@ $^
	- ranlib $@

install: $(SO_NAME)
	cp $(SO_NAME) /usr/local/lib
	ln -s $(SO_NAME) /usr/local/lib/$(SO_NAME0)
	ln -s $(SO_NAME) /usr/local/lib/$(SO_NAME1)
	cp ../Include/GraphBLAS.h  /usr/local/include

DINC = ../Demo/Include/*.h $(INC)
DSRC = ../Demo/Source/*.c
DCPPFLAGS = $(CPPFLAGS) -I../Demo/Include
DLIBS = $(SO_NAME) -lm
DSRC2 = $(notdir $(wildcard $(DSRC)))
DOBJ = $(DSRC2:.c=.o)

.KEEP: $(DOBJ)

%.o: ../Demo/Source/%.c $(DINC)
	$(CC) -c $(CFLAGS) $(DCPPFLAGS) $< -o $(notdir $@)

%_demo: ../Demo/Program/%_demo.c $(SO_NAME) $(DINC) $(DOBJ)
	$(CC) $(CFLAGS) $(DCPPFLAGS) $< $(DOBJ) $(DLIBS) -o $@

DEMO_PRG = $(notdir $(wildcard ../Demo/Program/*_demo.c))
DEMO = $(DEMO_PRG:.c=)

run: $(DEMO)
	./altdemo

clean:
	$(RM) -f *.o *.out *_out.m

distclean: clean
	$(RM) -rf *.dSYM $(DEMO) libgraphblas.*

purge: distclean

=== RBio/Demo/Makefile ===
#===============================================================================
# RBio/Demo/Makefile
#===============================================================================

default: all

include ../../SuiteSparse_config/SuiteSparse_config.mk

CLIB = $(LDFLAGS) -L../../lib -lrbio -lsuitesparseconfig $(LDLIBS)

C = $(CC) $(CF)

all: library RBdemo
	./RBdemo < ../RBio/private/west0479.rua

code: library

distclean: purge

purge: clean
	- $(RM) -r $(PURGE) RBdemo

clean:
	- $(RM) -r $(CLEAN) temp.rb

#-------------------------------------------------------------------------------
library:
	( cd ../../SuiteSparse_config ; $(MAKE) )
	( cd ../Lib ; $(MAKE) )
#-------------------------------------------------------------------------------

I = -I../../include

RBdemo: RBdemo.c
	$(C) -o RBdemo $(I) RBdemo.c $(CLIB)

=== SPQR/Demo/Makefile ===
#===============================================================================
# SuiteSparseQR/Demo/Makefile
#===============================================================================

default: all

ccode: all

include ../../SuiteSparse_config/SuiteSparse_config.mk

#-------------------------------------------------------------------------------
# the optional SPQRGPU module requires CUDA, SuiteSparse_GPURuntime, GPUQREngine
ifneq ($(GPU_CONFIG),)
    LIB_WITH_SPQRGPU = $(CUDART_LIB) $(CUBLAS_LIB) \
        -lSuiteSparse_GPURuntime -lGPUQREngine
    I_WITH_SPQRGPU = -I../../SuiteSparse_GPURuntime/Include \
        -I../../GPUQREngine/Include $(CUDA_INC)
else
    LIB_WITH_SPQRGPU = 
    I_WITH_SPQRGPU = 
endif

#-------------------------------------------------------------------------------

CLIB = $(LDFLAGS) -L../../lib -lspqr -lsuitesparseconfig -lcholmod -lamd \
        -lcolamd $(LIB_WITH_PARTITION) $(LIB_WITH_SPQRGPU) $(LDLIBS)

# use the BLAS and LAPACK defined by SuiteSparse_config.mk; do not use valgrind 
FLIB = $(LAPACK) $(BLAS)
V =

# To use Valgrind and the plain BLAS and plain LAPACK (non-optimized):
# FLIB = -lgfortran -llapack_plain -lblas_plain -lg2c
# V = valgrind --quiet

all: library qrdemo qrsimple qrsimplec gpu
	- $(V) ./qrsimple < ../Matrix/ash219.mtx
	- $(V) ./qrsimplec < ../Matrix/ash219.mtx
	- $(V) ./qrsimple < ../Matrix/west0067.mtx
	- $(V) ./qrsimplec < ../Matrix/west0067.mtx
	- $(V) ./qrdemo < ../Matrix/a2.mtx
	- $(V) ./qrdemo < ../Matrix/r2.mtx
	- $(V) ./qrdemo < ../Matrix/a04.mtx
	- $(V) ./qrdemo < ../Matrix/a2.mtx
	- $(V) ./qrdemo < ../Matrix/west0067.mtx
	- $(V) ./qrdemo < ../Matrix/c2.mtx
	- $(V) ./qrdemo < ../Matrix/a0.mtx
	- $(V) ./qrdemo < ../Matrix/lfat5b.mtx
	- $(V) ./qrdemo < ../Matrix/bfwa62.mtx
	- $(V) ./qrdemo < ../Matrix/LFAT5.mtx
	- $(V) ./qrdemo < ../Matrix/b1_ss.mtx
	- $(V) ./qrdemo < ../Matrix/bcspwr01.mtx
	- $(V) ./qrdemo < ../Matrix/lpi_galenet.mtx
	- $(V) ./qrdemo < ../Matrix/lpi_itest6.mtx
	- $(V) ./qrdemo < ../Matrix/ash219.mtx
	- $(V) ./qrdemo < ../Matrix/a4.mtx
	- $(V) ./qrdemo < ../Matrix/s32.mtx
	- $(V) ./qrdemo < ../Matrix/c32.mtx
	- $(V) ./qrdemo < ../Matrix/lp_share1b.mtx
	- $(V) ./qrdemo < ../Matrix/a1.mtx
	- $(V) ./qrdemo < ../Matrix/GD06_theory.mtx
	- $(V) ./qrdemo < ../Matrix/GD01_b.mtx
	- $(V) ./qrdemo < ../Matrix/Tina_AskCal_perm.mtx
	- $(V) ./qrdemo < ../Matrix/Tina_AskCal.mtx
	- $(V) ./qrdemo < ../Matrix/GD98_a.mtx
	- $(V) ./qrdemo < ../Matrix/Ragusa16.mtx
	- $(V) ./qrdemo < ../Matrix/young1c.mtx
	- $(V) ./qrdemo < ../Matrix/lp_e226_transposed.mtx

cdemo: qrdemoc
	- $(V) ./qrdemoc < ../Matrix/a2.mtx
	- $(V) ./qrdemoc < ../Matrix/r2.mtx
	- $(V) ./qrdemoc < ../Matrix/a04.mtx
	- $(V) ./qrdemoc < ../Matrix/a2.mtx
	- $(V) ./qrdemoc < ../Matrix/west0067.mtx
	- $(V) ./qrdemoc < ../Matrix/c2.mtx
	- $(V) ./qrdemoc < ../Matrix/a0.mtx
	- $(V) ./qrdemoc < ../Matrix/lfat5b.mtx
	- $(V) ./qrdemoc < ../Matrix/bfwa62.mtx
	- $(V) ./qrdemoc < ../Matrix/LFAT5.mtx
	- $(V) ./qrdemoc < ../Matrix/b1_ss.mtx
	- $(V) ./qrdemoc < ../Matrix/bcspwr01.mtx
	- $(V) ./qrdemoc < ../Matrix/lpi_galenet.mtx
	- $(V) ./qrdemoc < ../Matrix/lpi_itest6.mtx
	- $(V) ./qrdemoc < ../Matrix/ash219.mtx
	- $(V) ./qrdemoc < ../Matrix/a4.mtx
	- $(V) ./qrdemoc < ../Matrix/s32.mtx
	- $(V) ./qrdemoc < ../Matrix/c32.mtx
	- $(V) ./qrdemoc < ../Matrix/lp_share1b.mtx
	- $(V) ./qrdemoc < ../Matrix/a1.mtx
	- $(V) ./qrdemoc < ../Matrix/GD06_theory.mtx
	- $(V) ./qrdemoc < ../Matrix/GD01_b.mtx
	- $(V) ./qrdemoc < ../Matrix/Tina_AskCal_perm.mtx
	- $(V) ./qrdemoc < ../Matrix/Tina_AskCal.mtx
	- $(V) ./qrdemoc < ../Matrix/GD98_a.mtx
	- $(V) ./qrdemoc < ../Matrix/Ragusa16.mtx
	- $(V) ./qrdemoc < ../Matrix/young1c.mtx
	- $(V) ./qrdemoc < ../Matrix/lp_e226_transposed.mtx

ifneq ($(GPU_CONFIG),)
GPU_DEMOS = gpu2 gpu3 gpu4 gpu1
else
GPU_DEMOS =
endif

gpu: $(GPU_DEMOS)

gpu1: qrdemo_gpu
	- $(V) ./qrdemo_gpu  ../Matrix/west0067.mtx 2
	- $(V) ./qrdemo_gpu  ../Matrix/lp_e226_transposed.mtx 2
	- $(V) ./qrdemo_gpu  ../Matrix/lp_e226_transposed.mtx 6

gpu2: qrdemo_gpu2
	- $(V) ./qrdemo_gpu2 ../Matrix/west0067.mtx 2
	- $(V) ./qrdemo_gpu2 ../Matrix/lp_e226_transposed.mtx 2
	- $(V) ./qrdemo_gpu2 ../Matrix/lp_e226_transposed.mtx 6

gpu3: qrdemo_gpu3
	- $(V) ./qrdemo_gpu3 ../Matrix/west0067.mtx 2
	- $(V) ./qrdemo_gpu3 ../Matrix/lp_e226_transposed.mtx 2
	- $(V) ./qrdemo_gpu3 ../Matrix/lp_e226_transposed.mtx 6

gpu4: qrdemo_gpu
	- $(V) ./qrdemo_gpu  ../Matrix/Groebner_id2003_aug.mtx 6
	- $(V) ./qrdemo_gpu  ../Matrix/Franz6_id1959_aug.mtx 6

library: metis
	( cd ../Lib ; $(MAKE) )
	( cd ../../AMD ; $(MAKE) library )
	( cd ../../SuiteSparse_config ; $(MAKE) library )
	- ( cd ../../CHOLMOD && $(MAKE) library )
	- ( cd ../../COLAMD && $(MAKE) library )
	- ( cd ../../CCOLAMD && $(MAKE) library )
	- ( cd ../../CAMD && $(MAKE) library )
ifneq ($(GPU_CONFIG),)
	- ( cd ../../SuiteSparse_GPURuntime && $(MAKE) library )
	- ( cd ../../GPUQREngine && $(MAKE) library )
endif

metis: ../../include/metis.h

../../include/metis.h:
	- ( cd ../.. && $(MAKE) metis )

purge: distclean

distclean: clean
	- $(RM) qrdemo qrdemo_gpu qrdemoc qrsimple qrsimplec X.mtx
	- $(RM) R.mtx C.mtx E.txt gpu_results.txt qrdemo_gpu2 qrdemo_gpu3
	- $(RM) *.dot pfile tfile
	- $(RM) -r $(PURGE)

clean:
	- $(RM) -r $(CLEAN)

INC = ../Include/spqr.hpp ../Include/SuiteSparseQR_C.h \
	../Include/SuiteSparseQR_definitions.h \
	../Include/SuiteSparseQR.hpp Makefile

I = -I../../include $(I_WITH_SPQRGPU)

C = $(CXX) $(CF) $(SPQR_CONFIG) $(CONFIG_PARTITION) $(CONFIG_GPU) $(I) \
	$(CHOLMOD_CONFIG)

LIBS = $(CLIB) $(FLIB) $(TBB) $(GPULIB)

# With the CUDA BLAS
ifneq ($(GPU_CONFIG),)
LIBS += $(CUDART_LIB) $(CUBLAS_LIB)
endif

qrsimple: qrsimple.cpp $(INC)
	$(C) qrsimple.cpp -o qrsimple $(LIBS)

qrdemo: qrdemo.cpp $(INC)
	$(C) qrdemo.cpp -o qrdemo $(LIBS)

qrdemo_gpu: qrdemo_gpu.cpp $(INC)
ifneq ($(GPU_CONFIG),)
	$(C) qrdemo_gpu.cpp -o qrdemo_gpu $(LIBS)
else
	echo
endif

qrdemo_gpu2: qrdemo_gpu2.cpp $(INC)
ifneq ($(GPU_CONFIG),)
	$(C) qrdemo_gpu2.cpp -o qrdemo_gpu2 $(LIBS)
else
	echo
endif

qrdemo_gpu3: qrdemo_gpu3.cpp $(INC)
ifneq ($(GPU_CONFIG),)
	$(C) qrdemo_gpu3.cpp -o qrdemo_gpu3 $(LIBS)
else
	echo
endif

# compile the C code with gcc, but link with g++ to use SuiteSparseQR:

qrdemoc.o: qrdemoc.c $(INC)
	$(CC) $(CF) $(SPQR_CONFIG) $(I) -c $<

qrdemoc: qrdemoc.o $(INC)
	$(C) -o qrdemoc qrdemoc.o $(LIBS)

qrsimplec.o: qrsimplec.c $(INC)
	$(CC) $(CF) $(SPQR_CONFIG) $(CHOLMOD_CONFIG) $(I) -c $<

qrsimplec: qrsimplec.o $(INC)
	$(C) -o qrsimplec qrsimplec.o $(LIBS)

=== debian/changelog ===
suitesparse (1:5.7.1+dfsg-2) unstable; urgency=medium

  * libatomic.patch: new patch, should fix FTBFS on armel, mipsel, m68k
    and powerpc

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 29 Feb 2020 14:16:34 +0100

suitesparse (1:5.7.1+dfsg-1) unstable; urgency=medium

  * New upstream version 5.7.1+dfsg
  * d/copyright:
    + add GraphBLAS_API_C_v13.pdf to Files-Excluded
    + reflect upstream changes
  * libsuitesparse-doc: README.txt replaced by SuiteSparse_README.md
  * Bump S-V to 4.5.0

 -- Sébastien Villemot <sebastien@debian.org>  Wed, 26 Feb 2020 16:00:43 +0100

=== debian/control ===
Source: suitesparse
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Section: math
Priority: optional
Build-Depends: debhelper-compat (= 12),
               gfortran,
               libblas-dev,
               liblapack-dev,
               libmetis-dev,
               cmake,
               texlive-latex-extra,
               texlive-plain-generic,
               texlive-bibtex-extra,
               texlive-fonts-extra,
               ghostscript,
               texlive-science,
               texlive-xetex
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/suitesparse
Vcs-Git: https://salsa.debian.org/science-team/suitesparse.git
Homepage: http://www.suitesparse.com
Rules-Requires-Root: no

Package: libamd2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: approximate minimum degree ordering library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The AMD library provides a set of routines for pre-ordering sparse matrices
 prior to Cholesky or LU factorization, using the "Approximate Minimum Degree
 ordering" algorithm.

Package: libbtf1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: permutation to block triangular form library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The BTF library is a software package for permuting a matrix into Block upper
 Triangular Form. It includes a maximum transversal algorithm, which finds a
 permutation of a square or rectangular matrix so that it has a zero-free
 diagonal (if one exists); otherwise, it finds a maximal matching which
 maximizes the number of nonzeros on the diagonal. The package also includes a
 method for finding the strongly connected components of a graph. These two
 methods together give the permutation to block upper triangular form.

Package: libcamd2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: symmetric approximate minimum degree library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The CAMD library provides a set of routines for pre-ordering sparse matrices
 prior to Cholesky or LU factorization, using the approximate minimum degree
 ordering algorithm with optional ordering constraints.

Package: libcolamd2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: column approximate minimum degree ordering library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The COLAMD library implements the "COLumn Approximate Minimum Degree ordering"
 algorithm. It computes a permutation vector P such that the LU factorization
 of A (:,P) tends to be sparser than that of A. The Cholesky factorization of
 (A (:,P))'*(A (:,P)) will also tend to be sparser than that of A'*A.

Package: libccolamd2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: constrained column approximate library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The CCOLAMD library implements the "Constrained COLumn Approximate Minimum
 Degree ordering" algorithm. It computes a permutation vector P such that the
 LU factorization of A (:,P) tends to be sparser than that of A. The Cholesky
 factorization of (A (:,P))'*(A (:,P)) will also tend to be sparser than that
 of A'*A.

Package: libcholmod3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: sparse Cholesky factorization library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The CHOLMOD library provides a set of routines for factorizing sparse
 symmetric positive definite matrices of the form A or AA', updating/downdating
 a sparse Cholesky factorization, solving linear systems, updating/downdating
 the solution to the triangular system Lx=b, and many other sparse matrix
 functions for both symmetric and unsymmetric matrices. Its supernodal Cholesky
 factorization relies on LAPACK and the Level-3 BLAS, and obtains a substantial
 fraction of the peak performance of the BLAS.

Package: libcxsparse3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: concise sparse matrix library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The CXSparse library provides several matrix algorithms. The focus is on direct
 methods; iterative methods and solvers for eigenvalue problems are beyond the
 scope of this package.
 .
 The performance of the sparse factorization methods in CXSparse will not be
 competitive with UMFPACK or CHOLMOD, but the codes are much more concise and
 easy to understand. Other methods are competitive.

Package: libklu1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: circuit simulation sparse LU factorization library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The KLU library provides routines for LU factorization, primarily for circuit
 simulation.

Package: libldl2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: simple LDL' factorization library for sparse matrices
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The LDL library provides routines for sparse LDL' factorization and solving.
 These routines are not terrifically fast (they do not use dense matrix
 kernels), but the code is very short and concise. The purpose is to illustrate
 the algorithms in a very concise and readable manner, primarily for
 educational purposes.

Package: libumfpack5
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: sparse LU factorization library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The UMFPACK library provides a set of routines solving sparse linear systems
 via LU factorization.

Package: librbio2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: read/write sparse matrices in Rutherford/Boeing format
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 RBio is a library for reading/writing sparse matrices in the Rutherford/Boeing
 format.

Package: libspqr2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: sparse QR factorization library
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 SuiteSparseQR (SPQR) is a multithreaded, multifrontal, rank-revealing sparse
 QR factorization method.

Package: libgraphblas3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: graph algorithms via sparse matrix operations on semirings
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 SuiteSparse:GraphBLAS is an full implementation of the GraphBLAS standard,
 which defines a set of sparse matrix operations on an extended algebra of
 semirings using an almost unlimited variety of operators and types. When
 applied to sparse adjacency matrices, these algebraic operations are
 equivalent to computations on graphs. GraphBLAS provides a powerful and
 expressive framework for creating graph algorithms based on the elegant
 mathematics of sparse matrix operations on a semiring.

Package: libmongoose2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: graph partitioning tool that can quickly compute edge cuts (shared library)
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 Mongoose is a graph partitioning library that can quickly compute edge cuts in
 arbitrary graph. Given a graph with a vertex set and edge set, an edge cut is
 a partitioning of the graph into two subgraphs that are balanced (contain the
 same number of vertices) and the connectivity between the subgraphs is
 minimized (few edges are in the cut).
 .
 This package contains the shared C++ library.

Package: mongoose
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Suggests: libsuitesparse-doc
Description: graph partitioning tool that can quickly compute edge cuts (executable)
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 Mongoose is a graph partitioning library that can quickly compute edge cuts in
 arbitrary graph. Given a graph with a vertex set and edge set, an edge cut is
 a partitioning of the graph into two subgraphs that are balanced (contain the
 same number of vertices) and the connectivity between the subgraphs is
 minimized (few edges are in the cut).
 .
 This package contains the standalone executable.

Package: libsuitesparseconfig5
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: configuration routines for all SuiteSparse modules
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.
 .
 The SuiteSparse_config library provides configuration routines that are common
 to all SuiteSparse libraries.

Package: libsuitesparse-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libamd2 (= ${binary:Version}),
         libcamd2 (= ${binary:Version}),
         libbtf1 (= ${binary:Version}),
         libcolamd2 (= ${binary:Version}),
         libccolamd2 (= ${binary:Version}),
         libcholmod3 (= ${binary:Version}),
         libcxsparse3 (= ${binary:Version}),
         libgraphblas3 (= ${binary:Version}),
         libklu1 (= ${binary:Version}),
         libldl2 (= ${binary:Version}),
         libmongoose2 (= ${binary:Version}),
         libumfpack5 (= ${binary:Version}),
         librbio2 (= ${binary:Version}),
         libspqr2 (= ${binary:Version}),
         libsuitesparseconfig5 (= ${binary:Version}),
         libblas-dev | libblas.so,
         liblapack-dev | liblapack.so
Conflicts: libsuitesparse-metis-dev
Replaces: libsuitesparse-metis-dev
Description: libraries for sparse matrices computations (development files)
 Suitesparse is a collection of libraries for computations involving
 sparse matrices.  This package includes the following libraries:
 .
 AMD         approximate minimum degree ordering
 .
 CAMD        symmetric approximate minimum degree
 .
 BTF         permutation to block triangular form (beta)
 .
 COLAMD      column approximate minimum degree ordering
 .
 CCOLAMD     constrained column approximate minimum degree ordering
 .
 CHOLMOD     sparse Cholesky factorization
 .
 CXSparse    a concise sparse matrix package
 .
 KLU         sparse LU factorization, primarily for circuit simulation
 .

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

# Flags for traditional Makefiles (all libs except GraphBLAS and Mongoose)
COMMON_FLAGS := BLAS=-lblas MY_METIS_LIB=-lmetis
PIC_FLAGS := $(COMMON_FLAGS) OPTIMIZATION=-fPIC
NOPIC_FLAGS := $(COMMON_FLAGS) OPTIMIZATION=

# Flags for cmake (only GraphBLAS and Mongoose)
export CMAKE_OPTIONS := -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS) $(CPPFLAGS)" -DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS) $(CPPFLAGS)" -DCMAKE_SKIP_RPATH=TRUE -DCMAKE_BUILD_TYPE=Release

# All static libs (except GraphBLAS and Mongoose static which are handled by cmake)
STATIC_LIBS := CAMD/Lib/libcamd.a BTF/Lib/libbtf.a CHOLMOD/Lib/libcholmod.a AMD/Lib/libamd.a RBio/Lib/librbio.a LDL/Lib/libldl.a SuiteSparse_config/libsuitesparseconfig.a KLU/Lib/libklu.a SPQR/Lib/libspqr.a UMFPACK/Lib/libumfpack.a COLAMD/Lib/libcolamd.a CXSparse/Lib/libcxsparse.a CCOLAMD/Lib/libccolamd.a

PDF_DOCS := AMD/Doc/AMD_UserGuide.pdf CAMD/Doc/CAMD_UserGuide.pdf CHOLMOD/Doc/CHOLMOD_UserGuide.pdf GraphBLAS/Doc/GraphBLAS_UserGuide.pdf KLU/Doc/KLU_UserGuide.pdf Mongoose/Doc/Mongoose_UserGuide.pdf UMFPACK/Doc/UMFPACK_QuickStart.pdf UMFPACK/Doc/UMFPACK_UserGuide.pdf LDL/Doc/ldl_userguide.pdf SPQR/Doc/spqr_user_guide.pdf

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
JOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
JOBS := 1
endif


%:
	dh $@

# LD_LIBRARY_PATH needed to make tests work (since buildflags.patch removes the -rpath)
override_dh_auto_build:
	# Docs must be rebuilt first, because the build system expect them for some libs
	rm -f $(PDF_DOCS)
	make docs

	# Build static libraries (except GraphBLAS and Mongoose, see {graphblas,mongoose}-build.patch)
	make static $(NOPIC_FLAGS) JOBS=$(JOBS)
	mkdir static_lib && cp $(STATIC_LIBS) static_lib/
	make purge

	# Build dynamic libraries (and GraphBLAS and Mongoose static)
	LD_LIBRARY_PATH=$$(pwd)/lib make $(PIC_FLAGS) JOBS=$(JOBS)

override_dh_auto_install:
	# DESTDIR is used by cmake (for GraphBLAS and Mongoose), the INSTALL* vars are used by other libs
	make install $(PIC_FLAGS) INSTALL=$$(pwd)/debian/tmp/usr INSTALL_LIB=$$(pwd)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/ INSTALL_INCLUDE=$$(pwd)/debian/tmp/usr/include/suitesparse INSTALL_DOC=$$(pwd)/debian/tmp/usr/share/doc/suitesparse DESTDIR=$$(pwd)/debian/tmp
	# Install static libraries (except GraphBLAS and Mongoose)
	cp static_lib/* debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/

override_dh_auto_clean:
	make purge
	rm -rf static_lib
	rm -f $(PDF_DOCS)

override_dh_compress:
	dh_compress -X.pdf

## suitesparse 5.8.1%2Bdfsg

=== BTF/Makefile ===
#------------------------------------------------------------------------------
# BTF Makefile
#------------------------------------------------------------------------------

SUITESPARSE ?= $(realpath $(CURDIR)/..)
export SUITESPARSE

default: library

include ../SuiteSparse_config/SuiteSparse_config.mk

library:
	( cd Lib ; $(MAKE) )

# compile the static libraries only
static:
	( cd Lib    ; $(MAKE) static )

clean:
	( cd Lib ; $(MAKE) clean )
	( cd MATLAB ; $(RM) $(CLEAN) )

distclean:
	( cd Lib ; $(MAKE) distclean )
	( cd MATLAB ; $(RM) $(CLEAN) ; $(RM) *.mex* )

purge: distclean

# install BTF
install:
	( cd Lib ; $(MAKE) install )

# uninstall BTF
uninstall:
	( cd Lib ; $(MAKE) uninstall )
